#if !defined(AFX_BITFIELDCTRL_H__561F6C20_41F1_11D3_BC29_444553540000__INCLUDED_)
#define AFX_BITFIELDCTRL_H__561F6C20_41F1_11D3_BC29_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BitFieldCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CBitFieldCtrl window

class XBitCtrlList : public CListBox
{
protected:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP()
};

class CBitFieldCtrl;

class CBitCtrlList : public CMiniFrameWnd
{
protected:

public:
	void Invoke(CBitFieldCtrl* pParent, CPoint pt, int nWidth, int nStrings, CString* aStrings);
	void CancelWindow();
	void GetText(int nIndex, CString& rString);

protected:
	int m_nModalResult;
	XBitCtrlList m_wndList;
	BOOL m_bValid;
	BOOL m_bCanceled;

	CBitFieldCtrl* m_pParent;

public:
	virtual BOOL Create(CWnd* pParentWnd);
	void AddItem(LPCTSTR lpszText, BOOL bState);
	void GetItemState(int nIndex);

protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	afx_msg LONG OnSetFont(UINT hFont, LONG fRedraw);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnMeasureItem(int nID, LPMEASUREITEMSTRUCT lpmis);
	afx_msg void OnDrawItem(int nID, LPDRAWITEMSTRUCT lpdis);

	DECLARE_MESSAGE_MAP()
};

class CBitFieldCtrl : public CButton
{
// Construction
public:
	CBitFieldCtrl();

// Attributes
public:
	int m_nBitCount;
	DWORD m_dwValue;
	CString m_bitNames[32];
	CRect m_bitRect[32];
	CImageList m_images;
	CBitCtrlList* m_wndList;
	BOOL m_bJustGone;

// Operations
public:
	void SetValue(DWORD dwVal);
	void SetBitName(int nBit, CString strName);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBitFieldCtrl)
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL
	virtual int OnToolHitTest(CPoint point, TOOLINFO* pTI) const;

// Implementation
public:
	virtual ~CBitFieldCtrl();

	// Generated message map functions
protected:
	//{{AFX_MSG(CBitFieldCtrl)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

#define BFCN_BITSCHANGED		(0x100)

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BITFIELDCTRL_H__561F6C20_41F1_11D3_BC29_444553540000__INCLUDED_)
