// EditTriggerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "EditTriggerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditTriggerDlg dialog


CEditTriggerDlg::CEditTriggerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditTriggerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditTriggerDlg)
	m_nSourceX = 0;
	m_nSourceY = 0;
	m_nDestX = 0;
	m_nDestY = 0;
	m_nDestination = 0;
	m_nDestEvent = -1;
	m_nDestType = -1;
	//}}AFX_DATA_INIT
}


void CEditTriggerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditTriggerDlg)
	DDX_Text(pDX, IDC_TRIGGER_SRCX, m_nSourceX);
	DDV_MinMaxByte(pDX, m_nSourceX, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_SRCY, m_nSourceY);
	DDV_MinMaxByte(pDX, m_nSourceY, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_DESTX, m_nDestX);
	DDV_MinMaxByte(pDX, m_nDestX, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_DESTY, m_nDestY);
	DDV_MinMaxByte(pDX, m_nDestY, 0, 255);
	DDX_Text(pDX, IDC_TRIGGER_DEST, m_nDestination);
	DDX_CBIndex(pDX, IDC_TRIGGER_DESTEVENT, m_nDestEvent);
	DDX_Radio(pDX, IDC_TRIGGER_DESTISENTR, m_nDestType);
	//}}AFX_DATA_MAP

	if(m_nDestType == 0)
	{
		GetDlgItem(IDC_TRIGGER_DEST)->EnableWindow(TRUE);
		GetDlgItem(IDC_TRIGGER_DESTX)->EnableWindow(TRUE);
		GetDlgItem(IDC_TRIGGER_DESTY)->EnableWindow(TRUE);
		GetDlgItem(IDC_TRIGGER_DESTEVENT)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_TRIGGER_DEST)->EnableWindow(FALSE);
		GetDlgItem(IDC_TRIGGER_DESTX)->EnableWindow(FALSE);
		GetDlgItem(IDC_TRIGGER_DESTY)->EnableWindow(FALSE);
		GetDlgItem(IDC_TRIGGER_DESTEVENT)->EnableWindow(TRUE);
	}
}


BEGIN_MESSAGE_MAP(CEditTriggerDlg, CDialog)
	//{{AFX_MSG_MAP(CEditTriggerDlg)
	ON_BN_CLICKED(IDC_TRIGGER_DESTISENTR, OnTriggerDestisentr)
	ON_BN_CLICKED(IDC_TRIGGER_DESTISEVENT, OnTriggerDestisevent)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditTriggerDlg message handlers

BOOL CEditTriggerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString s;
	for(int i = 0; i < 256; i++)
	{
		s.Format("Event %d", i);
		((CComboBox*)GetDlgItem(IDC_TRIGGER_DESTEVENT))->AddString(s);
	}

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditTriggerDlg::OnTriggerDestisentr() 
{
	GetDlgItem(IDC_TRIGGER_DEST)->EnableWindow(TRUE);
	GetDlgItem(IDC_TRIGGER_DESTX)->EnableWindow(TRUE);
	GetDlgItem(IDC_TRIGGER_DESTY)->EnableWindow(TRUE);
	GetDlgItem(IDC_TRIGGER_DESTEVENT)->EnableWindow(FALSE);
}

void CEditTriggerDlg::OnTriggerDestisevent() 
{
	GetDlgItem(IDC_TRIGGER_DEST)->EnableWindow(FALSE);
	GetDlgItem(IDC_TRIGGER_DESTX)->EnableWindow(FALSE);
	GetDlgItem(IDC_TRIGGER_DESTY)->EnableWindow(FALSE);
	GetDlgItem(IDC_TRIGGER_DESTEVENT)->EnableWindow(TRUE);
}
