// FF4TreeView.h : interface of the CFF4TreeView class
//
/////////////////////////////////////////////////////////////////////////////

class CFF4TreeView : public CTreeView
{
protected: // create from serialization only
	CFF4TreeView();
	DECLARE_DYNCREATE(CFF4TreeView)

// Attributes
public:
	CFF4Doc* GetDocument();

protected:
	HTREEITEM m_hWorldMaps;
	HTREEITEM m_hLocationMaps1;
	HTREEITEM m_hLocationMaps2;
	HTREEITEM m_hEnemies;
	HTREEITEM m_hEvents;

// Operations
public:

protected:
	HTREEITEM GetNextItem(HTREEITEM hItem);
	void ExpandBranch(HTREEITEM hti);
	void ExpandAll();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFF4TreeView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFF4TreeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CFF4TreeView)
	afx_msg void OnSelChanged(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in FF4TreeView.cpp
inline CFF4Doc* CFF4TreeView::GetDocument()
   { return (CFF4Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
