// SepComboBox.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "SepComboBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSepComboBox

CSepComboBox::CSepComboBox()
{
}

CSepComboBox::~CSepComboBox()
{
}


BEGIN_MESSAGE_MAP(CSepComboBox, CComboBox)
	//{{AFX_MSG_MAP(CSepComboBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSepComboBox message handlers

void CSepComboBox::MeasureItem(LPMEASUREITEMSTRUCT lpmis) 
{
	lpmis->itemHeight = 16;
}

void CSepComboBox::DrawItem(LPDRAWITEMSTRUCT lpdis) 
{
	CDC dc;
	dc.Attach(lpdis->hDC);

	CRect rect = lpdis->rcItem;
	UINT nIndex = lpdis->itemID;

	if(nIndex != (UINT)-1)
	{
		CString strText;  GetLBText(nIndex, strText);
		DWORD dwData = lpdis->itemData;

		CRect textRect = rect;

		dc.FillSolidRect(textRect, ::GetSysColor((lpdis->itemState & ODS_SELECTED) ?
			COLOR_HIGHLIGHT : COLOR_WINDOW));
		if(lpdis->itemState & ODS_SELECTED) dc.DrawFocusRect(textRect);

		textRect.left += 2;

		CFont* oldFont = dc.SelectObject(GetFont());
		dc.SetBkMode(TRANSPARENT);
		dc.SetTextColor(::GetSysColor((lpdis->itemState & ODS_SELECTED) ?
			COLOR_HIGHLIGHTTEXT : COLOR_WINDOWTEXT));
		dc.DrawText(strText, &textRect, DT_LEFT | DT_VCENTER | DT_SINGLELINE | DT_NOPREFIX);
		dc.SelectObject(oldFont);

		if(dwData & 0x80000000 && !(lpdis->itemState & ODS_COMBOBOXEDIT))
		{
			CPen pen(PS_SOLID, 1, RGB(128, 128, 128));
			CPen* oldPen = dc.SelectObject(&pen);
			dc.MoveTo(rect.left, rect.bottom - 3);
			dc.LineTo(rect.right, rect.bottom - 3);
			dc.MoveTo(rect.left, rect.bottom - 1);
			dc.LineTo(rect.right, rect.bottom - 1);
			dc.SelectObject(oldPen);
		}
	}

	dc.Detach();
}
