// EditorInfoView.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "EditorInfoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorInfoView

IMPLEMENT_DYNCREATE(CEditorInfoView, cdxCSizingFormView)

CEditorInfoView::CEditorInfoView()
	: cdxCSizingFormView(CEditorInfoView::IDD)
{
	//{{AFX_DATA_INIT(CEditorInfoView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_bInit = FALSE;
}

CEditorInfoView::~CEditorInfoView()
{
}

void CEditorInfoView::DoDataExchange(CDataExchange* pDX)
{
	cdxCSizingFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditorInfoView)
	DDX_Control(pDX, IDC_MINBOUNDS, m_wndMinBounds);
	DDX_Control(pDX, IDC_EDINFO_TEXT, m_wndInfoText);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditorInfoView, cdxCSizingFormView)
	//{{AFX_MSG_MAP(CEditorInfoView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorInfoView diagnostics

#ifdef _DEBUG
void CEditorInfoView::AssertValid() const
{
	cdxCSizingFormView::AssertValid();
}

void CEditorInfoView::Dump(CDumpContext& dc) const
{
	cdxCSizingFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditorInfoView message handlers

void CEditorInfoView::OnInitialUpdate() 
{
	if(!m_bInit)
	{
		cdxCSizingFormView::OnInitialUpdate(m_wndMinBounds);

		AddSzControl(m_wndInfoText, mdResize, mdResize);

		ReorganizeControls();

		m_wndInfoText.SetBackgroundColor(FALSE, ::GetSysColor(COLOR_BTNFACE));

		CRect rect;  m_wndInfoText.GetClientRect(&rect);
		rect.DeflateRect(4, 4);
		m_wndInfoText.SetRect(rect);

		m_bInit = TRUE;
	}
}

