#if !defined(AFX_EVENTSFORMVIEW_H__50C2D200_3D1C_11D3_BC29_C2D811A5D839__INCLUDED_)
#define AFX_EVENTSFORMVIEW_H__50C2D200_3D1C_11D3_BC29_C2D811A5D839__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EventsFormView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEventsFormView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "cdxCSizingFormView.h"
#include "EventCodeList.h"
#include "BitFieldCtrl.h"
#include "SepComboBox.h"

class CEventsFormView : public cdxCSizingFormView
{
protected:
	CEventsFormView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CEventsFormView)

	CFF4Doc* GetDocument();

	CImageList m_images;

	void strParse(LPCTSTR string, LPCTSTR delim, CStringArray* array);
	void SetRichEditText(LPCTSTR lpszText);

	EventCommand* m_currentCmd;

// Form Data
public:
	//{{AFX_DATA(CEventsFormView)
	enum { IDD = IDD_EVENTSFORM };
	CBitFieldCtrl	m_wndBitField1;
	CButton	m_wndStaticBox;
	CStatic	m_wndLabel0;
	CStatic	m_wndLabel4;
	CStatic	m_wndLabel3;
	CStatic	m_wndLabel2;
	CStatic	m_wndLabel1;
	CRichEditCtrl	m_wndEventDescription;
	CSepComboBox	m_wndCombo1;
	CEdit	m_wndEditActual1;
	CEdit	m_wndEdit4;
	CEdit	m_wndEdit3;
	CEdit	m_wndEdit2;
	CEdit	m_wndEdit1;
	CButton	m_wndEventCodeClear;
	CStatic	m_wndStaticEvent;
	CStatic	m_wndStaticCommand;
	CComboBoxEx	m_wndEventCommand;
	CStatic	m_wndMinBounds;
	CStatic	m_wndSep2;
	CStatic	m_wndSep1;
	CButton	m_wndEventPlay;
	CButton	m_wndEventCodeUp;
	CButton	m_wndEventCodeDown;
	CButton	m_wndEventCodeDelete;
	CButton	m_wndEventCodeAdd;
	CComboBox	m_wndEventList;
	CEventCodeList	m_wndEventCode;
	//}}AFX_DATA

	int m_nCurrentEvent;

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEventsFormView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateCode();
	void UpdateControls();
	void UpdateParameterControls();
	int FindCommand(BYTE bCommand);
	int GetShortCommandDescription(EventCommand* pCommand, CString& desc);

	virtual ~CEventsFormView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CEventsFormView)
	afx_msg void OnChangeEventList();
	afx_msg void OnSelChangeEventCode();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

inline CFF4Doc* CEventsFormView::GetDocument()
   { return (CFF4Doc*)m_pDocument; }

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EVENTSFORMVIEW_H__50C2D200_3D1C_11D3_BC29_C2D811A5D839__INCLUDED_)
