CString g_eventCodesD0[] = {
	_T("Toggle screen shake"),										// D0
	_T("Flash the screen"),
	_T("Blur and unblur the entire screen"),
	_T("Command 0xD3"),
	_T("Invoke 'Fat Chocobo' screen"),
	_T("Open a door"),
	_T("Move screen up one tile and down one tile"),
	_T("Toggle character running"),
	_T("Toggle music fade"),										// D8
	_T("Invoke 'Namingway' screen"),
	_T("Toggle screen fade"),
	_T("Toggle the following status ailments: %s"),
	_T("Invoke Inn (costing %d GP)"),
	_T("Change visible character graphic to %d"),
	_T("Restore %d points of the party's HP"),
	_T("Restore %d points of the party's MP"),
	_T("Add item \"%s\" to inventory"),								// E0
	_T("Remove item \"%s\" from inventory"),
	_T("Command 0xE2 (0x%02X, 0x%02X)"),
	_T("Remove all status ailments except the following: %s"),
	_T("Add the following status ailments: %s"),
	_T("Give %d GP to party"),
	_T("Give %d GP to party"),
	_T("Add character %d to party"),
	_T("Remove character %d from party"),							// E8
	_T("Pause for %d units"),
	_T("Fade in song \"%s\""),
	_T("Repeat the following %d %s %d %s:"),
	_T("Enter battle with enemy set %d"),
	_T("Invoke shop %d"),
	_T("Command 0xEE (0x%02X)"),
	_T("Show message 0x1%02X from bank 2"),
	_T("Show message 0x0%02X from bank 1"),							// F0
	_T("Show message 0x1%02X from bank 1"),
	_T("Command 0xF2 (0x%02X)"),
	_T("Command 0xF3 (0x%02X)"),
	_T("Command 0xF4 (0x%02X)"),
	_T("Command 0xF5 (0x%02X)"),
	_T("Show message 0x%02X from bank 3"),
	_T("Invoke item selection window, asking for \"%s\""),
	_T("Show message 0x1%02X from bank 1 with \"Yes/No\" option"),	// F8
	_T("Tint screen with color 0x%02X"),
	_T("Play song \"%s\""),
	_T("Play sound effect %d"),
	_T("Command 0xFC"),
	_T("Play scripted effect %d"),
	_T("Load %s, placing the party at (%d, %d)"),
	_T("End Event:  Return control to player")							// FF
};

CString g_charMoves[] = {
	"Move %s up",
	"Move %s right",
	"Move %s down",
	"Move %s left",
	"Turn %s up",
	"Turn %s right",
	"Turn %s down",
	"Turn %s left",
	"Toggle visibility of %s",
	"%s, Special Move 1",
	"%s, Special Move 2",
	"%s, Special Move 3",
	"%s, Special Move 4",
	"%s, Special Move 5",
	"%s, Special Move 6",
	"%s, Special Move 7",
//	"Cause %s to appear",
//	"%s arm right",
//	"%s arm Left",
//	"Cause %s to put head down",
//	"Cause %s to appear dead",
//	"%s toggle strafe",
//	"%s toggle twirl"
};

COMBOBOXEXITEM g_charCommands[] = {
	{ 0, -1, "Character Movements", 0, 0, 0, 0, 0, 0xFFFFFFFF },
		{ 0, -1, "Move a character up", 0, -1, -1, 0, 1, 0x00 },
		{ 0, -1, "Move a character right", 0, -1, -1, 0, 1, 0x01 },
		{ 0, -1, "Move a character down", 0, -1, -1, 0, 1, 0x02 },
		{ 0, -1, "Move a character left", 0, -1, -1, 0, 1, 0x03 },
		{ 0, -1, "Turn a character up", 0, -1, -1, 0, 1, 0x04 },
		{ 0, -1, "Turn a character right", 0, -1, -1, 0, 1, 0x05 },
		{ 0, -1, "Turn a character down", 0, -1, -1, 0, 1, 0x06 },
		{ 0, -1, "Turn a character left", 0, -1, -1, 0, 1, 0x07 },
		{ 0, -1, "Toggle visibility of a character", 0, -1, -1, 0, 1, 0x08 },
		{ 0, -1, "Perform special move 1", 0, -1, -1, 0, 1, 0x09 },
		{ 0, -1, "Perform special move 2", 0, -1, -1, 0, 1, 0x0A },
		{ 0, -1, "Perform special move 3", 0, -1, -1, 0, 1, 0x0B },
		{ 0, -1, "Perform special move 4", 0, -1, -1, 0, 1, 0x0C },
		{ 0, -1, "Perform special move 5", 0, -1, -1, 0, 1, 0x0D },
		{ 0, -1, "Perform special move 6", 0, -1, -1, 0, 1, 0x0E },
		{ 0, -1, "Perform special move 7", 0, -1, -1, 0, 1, 0x0F },
	{ 0, -1, "Character Effects", 0, 0, 0, 0, 0, 0 },
		{ 0, -1, "Toggle running", 0, -1, -1, 0, 1, 0xD7 },
		{ 0, -1, "Change visible character", 0, -1, -1, 0, 1, 0xDD },
		{ 0, -1, "Add character to party", 0, -1, -1, 0, 1, 0xE7 },
		{ 0, -1, "Remove character from party", 0, -1, -1, 0, 1, 0xE8 },
	{ 0, -1, "Character Status", 0, 10, 10, 0, 0, 0 },
		{ 0, -1, "Toggle status ailments", 0, -1, -1, 0, 1, 0xDB },
		{ 0, -1, "Restore party's HP", 0, -1, -1, 0, 1, 0xDE },
		{ 0, -1, "Restore party's MP", 0, -1, -1, 0, 1, 0xDF },
		{ 0, -1, "Remove status ailments", 0, -1, -1, 0, 1, 0xE3 },
		{ 0, -1, "Add Status Ailments", 0, -1, -1, 0, 1, 0xE4 },
	{ 0, -1, "Map-Related Commands", 0, 3, 3, 0, 0, 0 },
		{ 0, -1, "Load Map", 0, -1, -1, 0, 1, 0xFE },
		{ 0, -1, "Open Door", 0, -1, -1, 0, 1, 0xD5 },
	{ 0, -1, "Visual Effects", 0, 9, 9, 0, 0, 0 },
		{ 0, -1, "Toggle Screen Shake", 0, -1, -1, 0, 1, 0xD0 },
		{ 0, -1, "Flash Screen", 0, -1, -1, 0, 1, 0xD1 },
		{ 0, -1, "Blur/Unblur Screen", 0, -1, -1, 0, 1, 0xD2 },
		{ 0, -1, "Move Screen Up and Down One Tile", 0, -1, -1, 0, 1, 0xD6 },
		{ 0, -1, "Toggle Screen Fade", 0, -1, -1, 0, 1, 0xDA },
		{ 0, -1, "Tint Screen", 0, -1, -1, 0, 1, 0xF9 },
		{ 0, -1, "Play Scripted Effect", 0, -1, -1, 0, 1, 0xFD },
	{ 0, -1, "Music", 0, 8, 8, 0, 0, 0 },
		{ 0, -1, "Toggle music fade", 0, -1, -1, 0, 1, 0xD8 },
		{ 0, -1, "Fade in song", 0, -1, -1, 0, 1, 0xEA },
		{ 0, -1, "Play song", 0, -1, -1, 0, 1, 0xFA },
		{ 0, -1, "Play sound effect", 0, -1, -1, 0, 1, 0xFB },
	{ 0, -1, "Timing and Flow Control", 0, 7, 7, 0, 0, 0 },
		{ 0, -1, "Pause", 0, -1, -1, 0, 1, 0xE9 },
		{ 0, -1, "Repeat the following actions", 0, -1, -1, 0, 1, 0xEB },
	{ 0, -1, "Inventory", 0, 4, 4, 0, 0, 0 },
		{ 0, -1, "Add item to inventory", 0, -1, -1, 0, 1, 0xE0 },
		{ 0, -1, "Remove item from inventory", 0, -1, -1, 0, 1, 0xE1 },
		{ 0, -1, "Give an amount of GP * 100", 0, -1, -1, 0, 1, 0xE5 },
		{ 0, -1, "Give an amount of GP * 50", 0, -1, -1, 0, 1, 0xE6 },
	{ 0, -1, "Battles", 0, 2, 2, 0, 0, 0 },
		{ 0, -1, "Enter a battle", 0, -1, -1, 0, 1, 0xEC },
	{ 0, -1, "Menus", 0, 1, 1, 0, 0, 0 },
		{ 0, -1, "Invoke 'Fat Chocobo' screen", 0, -1, -1, 0, 1, 0xD4 },
		{ 0, -1, "Invoke 'Namingway' screen", 0, -1, -1, 0, 1, 0xD9 },
		{ 0, -1, "Invoke 'Inn' (costing 50 * 2 ^ amount GP)", 0, -1, -1, 0, 1, 0xDC },
		{ 0, -1, "Invoke a shop", 0, -1, -1, 0, 1, 0xED },
		{ 0, -1, "Invoke item selection window", 0, -1, -1, 0, 1, 0xF7 },
	{ 0, -1, "Dialogue and Messages", 0, 5, 5, 0, 0, 0 },
		{ 0, -1, "Show message from bank 1", 0, -1, -1, 0, 1, 0xF0 },
		{ 0, -1, "Show message from bank 2", 0, -1, -1, 0, 1, 0xEF },
		{ 0, -1, "Show message from bank 3", 0, -1, -1, 0, 1, 0xF6 },
		{ 0, -1, "Show message from bank 1 with 'Yes/No' option", 0, -1, -1, 0, 1, 0xF8 },
	{ 0, -1, "* Currently Unknown Commands", 0, 12, 12, 0, 0, 0 },
		{ 0, -1, "0xD3", 0, -1, -1, 0, 1, 0xD3 },
		{ 0, -1, "0xE2", 0, -1, -1, 0, 1, 0xE2 },
		{ 0, -1, "0xEE", 0, -1, -1, 0, 1, 0xEE },
		{ 0, -1, "0xF2", 0, -1, -1, 0, 1, 0xF2 },
		{ 0, -1, "0xF3", 0, -1, -1, 0, 1, 0xF3 },
		{ 0, -1, "0xF4", 0, -1, -1, 0, 1, 0xF4 },
		{ 0, -1, "0xF5", 0, -1, -1, 0, 1, 0xF5 },
//		{ 0, -1, "0xFC", 0, -1, -1, 0, 1, 0xFC },
};

CString g_eventDescD0[] = {
	_T("|9,b|Visual Effects:  |9,b,008800|Toggle Screen Shake|d|\n"
		"Starts or stops random shaking of the screen, "
		"often used in earthquake scenes or during a large explosion.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),

	_T("|9,b|Visual Effects:  |9,b,008800|Flash Screen|d|\n"
		"Quickly flashes the screen by inverting the colors and returning them to normal.  "
		"This command is usually more useful when repeated several times.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),

	_T("|9,b|Visual Effects:  |9,b,008800|Blur/Unblur Screen|d|\n"
		"Blurs the screen with a mosaic effect, then returns it to normal.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),
	
	_T("|9,b|Command 0xD3|d|\n"
		"Purpose unknown at this time.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),
	
	_T("|9,b|Menus:  |9,b,008800|Invoke 'Fat Chocobo' Screen|d|\n"
		"Opens the 'Fat Chocobo' screen, allowing the player to store or retrieve items.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),
	
	_T("|9,b|Map-Related Commands:  |9,b,008800|Open Door|d|\n"
		"Opens a door.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),
	
	_T("|9,b|Visual Effects:  |9,b,008800|Move Screen Up and Down One Tile|d|\n"
		"Shifts the entire screen up one tile, and then back down to its original "
		"position.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),

	_T("|9,b|Character Effects:  |9,b,008800|Toggle Running|d|\n"
		"Toggles a running state for the main character, whether his movements "
		"are controlled by the player or in the event.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),

	_T("|9,b|Music:  |9,b,008800|Toggle Music Fade|d|\n"
		"Fades/unfades the music without having to stop it using another music command.  "
		"The song will continue to play at zero volume until this command is executed "
		"again.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),

	_T("|9,b|Menus:  |9,b,008800|Invoke 'Namingway' Screen|d|\n"
		"Opens the 'Namingway' screen, allowing the character to change the name of "
		"any character in the party.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),

	_T("|9,b|Visual Effects:  |9,b,008800|Toggle Screen Fade|d|\n"
		"Fades/unfades the screen.  Calling the command once will cause the screen "
		"to fade to black; calling it again will return the screen to normal.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tNone."),

	_T("|9,b|Character Status:  |9,b,008800|Toggle Status Ailments|d|\n"
		"Toggles status ailments for the entire party.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|bitmask:|d|  Specifies which status ailments to toggle."),

	_T("|9,b|Menus:  |9,b,008800|Invoke 'Inn'|d|\n"
		"Causes an 'Inn' requester to appear.  This command does not carry out the actual "
		"action to recover the characters; it only brings up the window that asks the "
		"player to pay the fee.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|gold:|d|  Specifies how much gold a night at the inn will cost.  The formula "
		"|8,b|50 * 2 ^ |8,bi|gold|d| is used to calculate the actual amount."),

	_T("|9,b|Character Effects:  |9,b,008800|Change Visible Character Graphic|d|\n"
		"Switches the visible character.  This is often used in events when a certain "
		"character is needed, but since the player can change the character who is "
		"visible, it is impossible to predict who is currently being shown.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|character:|d|  Specifies the character to be made visible."),

	_T("|9,b|Character Status:  |9,b,008800|Restore HP|d|\n"
		"Heals a specified amount of HP for each character in the party, not to exceed "
		"the maximum amount of HP for each.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|hp:|d|  Specifies how much HP to restore.  The formula "
		"|8,b|10 * |8,bi|hp|d| is used to calculate the actual amount."),

	_T("|9,b|Character Status:  |9,b,008800|Restore MP|d|\n"
		"Heals a specified amount of MP for each character in the party, not to exceed "
		"the maximum amount of MP for each.  Obviously, if a character cannot use "
		"magic, no MP will be restored to him or her.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|mp:|d|  Specifies how much MP to restore.  The formula "
		"|8,b|10 * |8,bi|mp|d| is used to calculate the actual amount."),

	_T("|9,b|Inventory:  |9,b,008800|Add Item|d|\n"
		"Adds an item to the party's inventory.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|item:|d|  Specifies the item to be added."),

	_T("|9,b|Inventory:  |9,b,008800|Remove Item|d|\n"
		"Removes an item from the party's inventory.  If the item does not exist in "
		"the inventory, nothing will be changed.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|item:|d|  Specifies the item to be removed."),

	_T("|9,b|Command 0xE2|d|\n"
		"Purpose unknown at this time.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tThis command takes two parameters."),

	_T("|9,b|Character Status:  |9,b,008800|Remove Status Ailments|d|\n"
		"Removes all status ailments, |8,b|except|d| the ones specified.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|bitmask:|d|  Specifies which status ailments that |8,b|will not|d| be removed."),

	_T("|9,b|Character Status:  |9,b,008800|Add Status Ailments|d|\n"
		"Forcibly inflicts status ailments upon each character in the party.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|bitmask:|d|  Specifies which status ailments to add."),

	_T("|9,b|Inventory:  |9,b,008800|Give GP * 100|d|\n"
		"Gives the party an amount of GP.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|gold:|d|  Specifies how much gold will be given to the party.  The formula "
		"|8,b|100 * |8,bi|gold|d| is used to calculate the actual amount."),

	_T("|9,b|Inventory:  |9,b,008800|Give GP * 50|d|\n"
		"Gives the party an amount of GP.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|gold:|d|  Specifies how much gold will be given to the party.  The formula "
		"|8,b|50 * |8,bi|gold|d| is used to calculate the actual amount."),

	_T("|9,b|Character Effects:  |9,b,008800|Add Character|d|\n"
		"Adds a character to the party.  If the character is already in the party, "
		"nothing will change.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|character:|d|  Specifies which character to add."),

	_T("|9,b|Character Effects:  |9,b,008800|Remove Character|d|\n"
		"Removes a character from the party.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|character:|d|  Specifies which character to remove."),

	_T("|9,b|Timing and Flow Control:  |9,b,008800|Pause|d|\n"
		"Pause the game for a specified number of units.  The exact length of these units is "
		"currently unknown.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|units:|d|  Specifies the length of time to pause the game."),

	_T("|9,b|Music:  |9,b,008800|Fade in Song|d|\n"
		"Plays a song, fading it in from zero volume to full volume. "
		"This differs from the other music command, which starts a song at full volume.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|song:|d|  Specifies the song to be played."),

	_T("|9,b|Timing and Flow Control:  |9,b,008800|Repeat the Following Actions|d|\n"
		"Repeats the specified number of script actions a certain number of times.  This can "
		"be used to greatly reduce the size of an event by repeating several instances of the "
		"same action, such as having a character walk up the screen multiple times.  There may "
		"be some sort of pause between each action--this command is not yet fully understood.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|iterations:|d|  Specifies the number of times the actions are to be executed.\n"
		"\t|9,i|actions:|d|  Specifies the number of actions to be repeated."),

	_T("|9,b|Battles:  |9,b,008800|Enter Battle|d|\n"
		"Forcibly causes a battle to occur.  This battle, other than not being random, is otherwise "
		"exactly a typical battle.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|enemyCombination:|d|  Specifies the enemy combination that will be used in the battle. "
		"If the characters are currently in the overworld, enemy combinations from bank 1 are used--if "
		"they are in the underground or on the moon, bank 2 combinations are used."),

	_T("|9,b|Menus:  |9,b,008800|Invoke Shop|d|\n"
		"Brings up a shop screen, allowing the player to buy and sell items.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|shop:|d|  Specifies the shop to display."),

	_T("|9,b|Command 0xEE|d|\n"
		"Purpose unknown at this time.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tThis command takes one parameter."),

	_T("|9,b|Dialogue and Messages: |9,b,008800|Display Message from Bank 2|d|\n"
		"Displays a message from bank 2, within the range 0x100 to 0x1FF, inclusive.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|message:|d|  Specifies the message to be displayed."),

	_T("|9,b|Dialogue and Messages: |9,b,008800|Display Message from Bank 1|d|\n"
		"Displays a message from bank 1, within the range 0x000 to 0x0FF, inclusive.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|message:|d|  Specifies the message to be displayed."),

	_T("|9,b|Dialogue and Messages: |9,b,008800|Display Message from Bank 1|d|\n"
		"Displays a message from bank 1, within the range 0x100 to 0x1FF, inclusive.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|message:|d|  Specifies the message to be displayed."),

	_T("|9,b|Command 0xF2|d|\n"
		"Purpose unknown at this time.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tThis command takes one parameter."),

	_T("|9,b|Command 0xF3|d|\n"
		"Purpose unknown at this time.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tThis command takes one parameter."),

	_T("|9,b|Command 0xF4|d|\n"
		"Purpose unknown at this time.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tThis command takes one parameter."),

	_T("|9,b|Command 0xF5|d|\n"
		"Purpose unknown at this time.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\tThis command takes one parameter."),

	_T("|9,b|Dialogue and Messages: |9,b,008800|Display Message from Bank 3|d|\n"
		"Displays a message from bank 3, within the range 0x00 to 0xFF, inclusive.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|message:|d|  Specifies the message to be displayed."),

	_T("|9,b|Menus: |9,b,008800|Invoke \"Item Selection\" Window|d|\n"
		"Displays the item selection window at the bottom of the screen.  The player is "
		"to select an item from the window.  If the specified item is selected, execution of "
		"the event continues; if any other item is selected, control is |8,b|immediately|d| returned "
		"to the player.  For this reason, you want to make sure this command is executed only when "
		"no \"lingering\" characters are present, because there will be no chance to remove them from "
		"the screen.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|item:|d|  Specifies the item that should be selected for the event to continue."),

	_T("|9,b|Dialogue and Messages: |9,b,008800|Display Message from Bank 1 with \"Yes/No\" Option|d|\n"
		"Displays a message from bank 1, within the range 0x100 to 0x1FF, inclusive.  Also displayed "
		"is a window from which the user can choose \"Yes\" or \"No\" in response to the message "
		"displayed.  If \"Yes\" is selected, execution of the event continues; if \"No\" is selected, "
		"execution of this event stops and execution of the |8,b|next|d| event numerically begins.  "
		"For example, if the user selectes \"No\" during event 0x3F, that event will stop and "
		"event 0x40 will begin.  For this reason, events that use this command need to be carefully "
		"planned so the very next event can be used in response to a \"No\" selection.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|message:|d|  Specifies the message to be displayed."),

	_T("|9,b|Visual Effects:  |9,b,008800|Tint Screen|d|\n"
		"Tints the screen to the specified color.  This is actually a toggle; the second instance "
		"of this command will restore the screen to its original state, regardless of the value of "
		"the parameter.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|color:|d|  Specifies the color to tint the screen.  The specifics of this parameter "
		"are not fully known at this time."),

	_T("|9,b|Music:  |9,b,008800|Play Song|d|\n"
		"Plays a song, starting it at full volume. "
		"This differs from the other music command, which slowly fades in a song.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|song:|d|  Specifies the song to be played."),

	_T("|9,b|Music:  |9,b,008800|Play Sound Effect|d|\n"
		"Plays a sound effect.\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|sound:|d|  Specifies the sound effect to be played.  These will likely be "
		"catalogued in the future."),

	_T("|9,b|Command 0xFC|d|\n"
		"As far as I know, this command is not used in Final Fantasy 2.  If this is the case, "
		"it will be used in the future to create extended commands to add features to the game "
		"engine through the use of code plug-ins."),

	_T("|9,b|Visual Effects:  |9,b,008800|Play Scripted Effect|d|\n"
		"Plays a scripted effect.  There is still a lot of information about these effects that "
		"is not known--a scripted effect is usually a complex graphical and sound effect such as "
		"the bombs flying around Mist as it is being destroyed.  Once more information is discovered, "
		"there will be more ways to use these effects.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|effect:|d|  Specifies the effect to execute."),

	_T("|9,b|Map-Related Commands:  |9,b,008800|Load Map|d|\n"
		"Loads the specified map and places the party at a certain position.|d|\n\n"
		"|9,b|Parameters:|d|\n"
		"\t|9,i|map:|d|  Specifies the map to load.  There are three special cases--251 represents "
		"the overworld map, 252 represents the underground, and 253 represents the moon.  The actual "
		"map loaded depends on the bank selected below.\n"
		"\t|9,i|xpos:|d|  Specifies the horizontal location to place the characters on the map.\n"
		"\t|9,i|ypos:|d|  Specifies the vertical location to place the characters on the map.\n"
		"\t|9,i|bank:|d|  Specifies the bank from which the location will be loaded.  Locations in bank "
		"0 typically represent locations in the overworld, and locations in bank 1 represent locations "
		"in the underground or on the moon."),

	_T("|9,b|End Event:  Return control to player|d|\n"
		"Causes execution of the event to stop, returning total control to the character.")
};

LPCTSTR g_songTitles[] = {
	// Subract one from the actual song value--"Stop Music" isn't placed here
	// because this list needs to be sorted separately.
	_T("Prologue..."),
	_T("Long Way to Go"),
	_T("Fanfare 2"),
	_T("Chocobo-Chocobo"),
	_T("Samba de Chocobo"),
	_T("Land of Dwarves"),
	_T("The Final Battle"),
	_T("Fanfare"),
	_T("Welcome to Our Town!"),
	_T("Rydia"),
	_T("The Dreadful Battle"),
	_T("Mount Ordeals"),
	_T("Main Theme"),
	_T("The Big Whale"),
	_T("Cry in Sorrow, Part II"),
	_T("Good Night"),
	_T("Golbeza, Clad in Dark"),
	_T("Melody of Lute"),
	_T("Theme of Love"),
	_T("Kingdom of Baron"),
	_T("The Prelude"),
	_T("Somewhere in the World"),
	_T("The Tower of Bab-il"),
	_T("The Airship"),
	_T("Tower of Zot"),
	_T("Fight 2"),
	_T("Within the Giant"),
	_T("Illusionary World"),
	_T("Ring of Bomb"),
	_T("The Lunarians"),
	_T("Surprise"),
	_T("Giott, the Great King"),
	_T("Palom and Porom"),
	_T("Dancing Calobrena"),
	_T("Run!"),
	_T("Hey, Cid!"),
	_T("Into the Darkness"),
	_T("Dancing Girls' Theme"),
	_T("Fight 1"),
	_T("Castle Damcyan"),
	_T("Join the Party!"),
	_T("Cry in Sorrow, Part I"),
	_T("Chocobo's Forest"),
	_T("Red Wings"),
	_T("Suspicion"),
	_T("Fabul"),
	_T("The Paladin"),
	_T("Hello!  Big Chocobo!"),
	_T("Another Moon"),
	_T("Toroian Beauty"),
	_T("Mystic Mysidian"),
	_T("Lunar Subterrane"),
	_T("Epilogue, Part I"),
	_T("Epilogue, Part II"),
	_T("Epilogue, Part III"),
	_T("? (0x38)"),
	_T("? (0x39)"),
	_T("? (0x3A)"),
	_T("? (0x3B)"),
	_T("? (0x3C)"),
	_T("? (0x3D)"),
	_T("Propellor?"),
	_T("Ship leaving Fabul Harbor"),
	_T("Door opening"),
	_T("Door opening 2"),
	_T("Crumbling"),
	_T("Falling"),
	_T("Waterfall"),
	_T("? (0x45)"),
};

int compare(const void *arg1, const void *arg2)
{
	return lstrcmpi(*(TCHAR**)arg1, *(TCHAR**)arg2);
}
