// MainFrame.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

typedef struct __FLEXPANE
{
	UINT nID;					// Resource ID for menus and toolbars
	CRuntimeClass* pClass;		// Class for the new pane
	DWORD dwData;				// View-specific data to be sent when the view is initialized
	CWnd* pBand;				// Class of an option second toolbar band
} FLEXPANE;

class CMainFrame : public CFrameWnd
{
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

protected:
	BOOL m_bFirstTime;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual void ActivateFrame(int nCmdShow = -1);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:  // control bar embedded members
	CSplitterWnd m_wndSplitter;
	CStatusBar  m_wndStatusBar;
	CReBar      m_wndReBar;
	CToolBar    m_wndToolBar;

	CWnd*		m_pBand;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnClose();
	//}}AFX_MSG
	afx_msg LONG OnUpdateFlexPane(UINT pClass, LONG pData);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
