// MapTileCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "MapTileCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapTileCtrl

CMapTileCtrl::CMapTileCtrl()
{
}

CMapTileCtrl::~CMapTileCtrl()
{
}

IMPLEMENT_DYNCREATE(CMapTileCtrl, CWnd)

BEGIN_MESSAGE_MAP(CMapTileCtrl, CWnd)
	//{{AFX_MSG_MAP(CMapTileCtrl)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_NOTIFY_REFLECT(PGN_CALCSIZE, OnCalcSize)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMapTileCtrl message handlers

int CMapTileCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_wndTileList.Create(WS_CHILD | WS_VISIBLE | LBS_OWNERDRAWFIXED | LBS_MULTICOLUMN,
		CRect(0, 0, 22 * 128, 0), this, 1001);
	m_wndTileList.ModifyStyleEx(0, WS_EX_CLIENTEDGE);

	Pager_SetChild(GetSafeHwnd(), m_wndTileList.GetSafeHwnd());

	return 0;
}

void CMapTileCtrl::OnCalcSize(NMHDR* pNotifyStruct, LRESULT* result)
{
	LPNMPGCALCSIZE pCalcSize = (LPNMPGCALCSIZE)pNotifyStruct;

	MessageBeep(MB_OK);
	switch(pCalcSize->dwFlag)
	{
		case PGF_CALCWIDTH:
		{
			pCalcSize->iWidth = 22 * 128;
			break;
		}
		case PGF_CALCHEIGHT:
		{
			pCalcSize->iHeight = 26;
			break;
		}
	}

	*result = 0;
}

BOOL CMapTileCtrl::Create(CWnd* pParentWnd, UINT nID) 
{
	return CWnd::Create(WC_PAGESCROLLER, NULL, PGS_HORZ | WS_CHILD | WS_VISIBLE,
		CRect(0, 0, 0, 0), pParentWnd, nID);
}
