// MapTileFloatWnd.cpp : implementation file
//

#include "stdafx.h"
#include "FF4Edit.h"
#include "MapTileFloatWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapTileFloatWnd

IMPLEMENT_DYNCREATE(CMapTileFloatWnd, CMiniFrameWnd)

CMapTileFloatWnd::CMapTileFloatWnd()
{
}


BEGIN_MESSAGE_MAP(CMapTileFloatWnd, CMiniFrameWnd)
	//{{AFX_MSG_MAP(CMapTileFloatWnd)
	ON_WM_CLOSE()
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapTileFloatWnd message handlers

void CMapTileFloatWnd::OnClose() 
{
	ShowWindow(SW_HIDE);
}

int CMapTileFloatWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMiniFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_wndTileList.Create(WS_CHILD | WS_VISIBLE | LBS_OWNERDRAWFIXED | LBS_MULTICOLUMN |
		WS_HSCROLL | LBS_NOINTEGRALHEIGHT, CRect(0, 0, 0, 0), this, 1001);
	m_wndTileList.SetColumnWidth(22);
	m_wndTileList.SetItemHeight(0, 22);
	m_wndTileList.ModifyStyleEx(0, WS_EX_CLIENTEDGE);
	
	return 0;
}

void CMapTileFloatWnd::OnSize(UINT nType, int cx, int cy) 
{
	CMiniFrameWnd::OnSize(nType, cx, cy);
	
	m_wndTileList.MoveWindow(0, 0, cx, cy);
}
