#if !defined(AFX_WORLDENEMYVIEW_H__7A145AC0_50EA_11D3_BC29_DFF7F4F5B238__INCLUDED_)
#define AFX_WORLDENEMYVIEW_H__7A145AC0_50EA_11D3_BC29_DFF7F4F5B238__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// WorldEnemyView.h : header file
//

#include "WorldBaseView.h"

/////////////////////////////////////////////////////////////////////////////
// CWorldEnemyView view

class CWorldEnemyView : public CWorldBaseView
{
protected:
	CWorldEnemyView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CWorldEnemyView)

// Attributes
public:
	CFF4Doc* GetDocument();

protected:
	CPoint m_ptCurrentRegion;

	CFont m_font, m_fontBold;
	
	CComboBox m_wndEnemySets;
	CSliderCtrl m_wndEnemyOdds;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWorldEnemyView)
	public:
	virtual BOOL OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll = TRUE);
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CWorldEnemyView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CWorldEnemyView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	afx_msg void OnChangeEnemySet();
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MapView.cpp
inline CFF4Doc* CWorldEnemyView::GetDocument()
   { return (CFF4Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WORLDENEMYVIEW_H__7A145AC0_50EA_11D3_BC29_DFF7F4F5B238__INCLUDED_)
